 /*
 * # Semantic UI
 * https://github.com/Semantic-Org/Semantic-UI
 * http://beta.semantic-ui.com/
 *
 * Copyright 2014 Contributors
 * Released under the MIT license
 * http://opensource.org/licenses/MIT
 *
 */
!function(e,t,a,n){"use strict";e.tab=e.fn.tab=function(a){var i,o,r=e(e.isFunction(this)?t:this),s=e.isPlainObject(a)?e.extend(!0,{},e.fn.tab.settings,a):e.extend({},e.fn.tab.settings),c=r.selector||"",l=(new Date).getTime(),u=[],d=arguments[0],b="string"==typeof d,g=[].slice.call(arguments,1);return r.each(function(){var a,f,h,p,m=s.className,v=s.metadata,y=s.selector,T=s.error,x="."+s.namespace,A="module-"+s.namespace,P=e(this),C=e(y.tabs),E={},z=!0,S=0,w=this,F=P.data(A);i={initialize:function(){i.debug("Initializing tab menu item",P),s.context&&(i.determineTabs(),i.debug("Using only tabs inside context",s.context,C)),s.auto&&(i.verbose("Setting up automatic tab retrieval from server"),s.apiSettings={url:s.path+"/{$tab}"}),e.isWindow(w)||(i.debug("Attaching tab activation events to element",P),P.on("click"+x,i.event.click)),i.instantiate()},determineTabs:function(){var t;"parent"===s.context?(P.closest("."+m.ui).size()>0?(t=P.closest("."+m.ui),i.verbose("Using closest UI element for determining parent",t)):t=P,a=t.parent(),i.verbose("Determining parent element for creating context",a)):(a=e(s.context),i.verbose("Using selector for tab context",s.context,a)),s.childrenOnly?(C=a.children(y.tabs),i.debug("Searching tab context children for tabs",a,C)):(C=a.find(y.tabs),i.debug("Searching tab context for tabs",a,C))},initializeHistory:function(){if(s.history){if(i.debug("Initializing page state"),e.address===n)return i.error(T.state),!1;if("state"==s.historyType){if(i.debug("Using HTML5 to manage state"),s.path===!1)return i.error(T.path),!1;e.address.history(!0).state(s.path)}e.address.bind("change",i.event.history.change)}},instantiate:function(){i.verbose("Storing instance of module",i),P.data(A,i)},destroy:function(){i.debug("Destroying tabs",P),P.removeData(A).off(x)},event:{click:function(t){var a=e(this).data(v.tab);a!==n?(s.history?(i.verbose("Updating page state",t),e.address.value(a)):(i.verbose("Changing tab",t),i.changeTab(a)),t.preventDefault()):i.debug("No tab specified")},history:{change:function(t){var a=t.pathNames.join("/")||i.get.initialPath(),o=s.templates.determineTitle(a)||!1;i.performance.display(),i.debug("History change event",a,t),p=t,a!==n&&i.changeTab(a),o&&e.address.title(o)}}},refresh:function(){f&&(i.debug("Refreshing tab",f),i.changeTab(f))},cache:{read:function(e){return e!==n?E[e]:!1},add:function(e,t){e=e||f,i.debug("Adding cached content for",e),E[e]=t},remove:function(e){e=e||f,i.debug("Removing cached content for",e),delete E[e]}},set:{state:function(t){e.address.value(t)}},changeTab:function(a){var n=t.history&&t.history.pushState,o=n&&s.ignoreFirstLoad&&z,r=s.auto||e.isPlainObject(s.apiSettings),c=r&&!o?i.utilities.pathToArray(a):i.get.defaultPathArray(a);a=i.utilities.arrayToPath(c),e.each(c,function(t,n){var l,u,d,b,g=c.slice(0,t+1),m=i.utilities.arrayToPath(g),v=i.is.tab(m),y=t+1==c.length,x=i.get.tabElement(m);return i.verbose("Looking for tab",n),v?(i.verbose("Tab was found",n),f=m,h=i.utilities.filterArray(c,g),y?b=!0:(u=c.slice(0,t+2),d=i.utilities.arrayToPath(u),b=!i.is.tab(d),b&&i.verbose("Tab parameters found",u)),b&&r?(o?(i.debug("Ignoring remote content on first tab load",m),z=!1,i.cache.add(a,x.html()),i.activate.all(m),e.proxy(s.onTabInit,x)(m,h,p),e.proxy(s.onTabLoad,x)(m,h,p)):(i.activate.navigation(m),i.content.fetch(m,a)),!1):(i.debug("Opened local tab",m),i.activate.all(m),i.cache.read(m)||(i.cache.add(m,!0),i.debug("First time tab loaded calling tab init"),e.proxy(s.onTabInit,x)(m,h,p)),e.proxy(s.onTabLoad,x)(m,h,p),void 0)):(l=e(-1==a.search("/")?"#"+a+', a[name="'+a+'"]':"#qqq"),m=l.closest("[data-tab]").data("tab"),x=i.get.tabElement(m),l&&l.size()>0&&m?(i.debug("No tab found, but deep anchor link present, opening parent tab"),i.activate.all(m),i.cache.read(m)||(i.cache.add(m,!0),i.debug("First time tab loaded calling tab init"),e.proxy(s.onTabInit,x)(m,h,p))):i.error(T.missingTab,P,m),!1)})},content:{fetch:function(t,a){var o,r,c=i.get.tabElement(t),l={dataType:"html",stateContext:c,onSuccess:function(n){i.cache.add(a,n),i.content.update(t,n),t==f?(i.debug("Content loaded",t),i.activate.tab(t)):i.debug("Content loaded in background",t),e.proxy(s.onTabInit,c)(t,h,p),e.proxy(s.onTabLoad,c)(t,h,p)},urlData:{tab:a}},u=c.data(v.promise)||!1,d=u&&"pending"===u.state();a=a||t,r=i.cache.read(a),s.cache&&r?(i.debug("Showing existing content",a),i.content.update(t,r),i.activate.tab(t),e.proxy(s.onTabLoad,c)(t,h,p)):d?(i.debug("Content is already loading",a),c.addClass(m.loading)):e.api!==n?(o=e.extend(!0,{headers:{"X-Remote":!0}},s.apiSettings,l),i.debug("Retrieving remote content",a,o),e.api(o)):i.error(T.api)},update:function(e,t){i.debug("Updating html for",e);var a=i.get.tabElement(e);a.html(t)}},activate:{all:function(e){i.activate.tab(e),i.activate.navigation(e)},tab:function(e){var t=i.get.tabElement(e);i.verbose("Showing tab content for",t),t.addClass(m.active).siblings(C).removeClass(m.active+" "+m.loading)},navigation:function(e){var t=i.get.navElement(e);i.verbose("Activating tab navigation for",t,e),t.addClass(m.active).siblings(r).removeClass(m.active+" "+m.loading)}},deactivate:{all:function(){i.deactivate.navigation(),i.deactivate.tabs()},navigation:function(){r.removeClass(m.active)},tabs:function(){C.removeClass(m.active+" "+m.loading)}},is:{tab:function(e){return e!==n?i.get.tabElement(e).size()>0:!1}},get:{initialPath:function(){return r.eq(0).data(v.tab)||C.eq(0).data(v.tab)},path:function(){return e.address.value()},defaultPathArray:function(e){return i.utilities.pathToArray(i.get.defaultPath(e))},defaultPath:function(e){var t=r.filter("[data-"+v.tab+'^="'+e+'/"]').eq(0),a=t.data(v.tab)||!1;if(a){if(i.debug("Found default tab",a),S<s.maxDepth)return S++,i.get.defaultPath(a);i.error(T.recursion)}else i.debug("No default tabs found for",e,C);return S=0,e},navElement:function(e){return e=e||f,r.filter("[data-"+v.tab+'="'+e+'"]')},tabElement:function(e){var t,a,n,o;return e=e||f,n=i.utilities.pathToArray(e),o=i.utilities.last(n),t=C.filter("[data-"+v.tab+'="'+o+'"]'),a=C.filter("[data-"+v.tab+'="'+e+'"]'),t.size()>0?t:a},tab:function(){return f}},utilities:{filterArray:function(t,a){return e.grep(t,function(t){return-1==e.inArray(t,a)})},last:function(t){return e.isArray(t)?t[t.length-1]:!1},pathToArray:function(e){return e===n&&(e=f),"string"==typeof e?e.split("/"):[e]},arrayToPath:function(t){return e.isArray(t)?t.join("/"):!1}},setting:function(t,a){if(i.debug("Changing setting",t,a),e.isPlainObject(t))e.extend(!0,s,t);else{if(a===n)return s[t];s[t]=a}},internal:function(t,a){if(e.isPlainObject(t))e.extend(!0,i,t);else{if(a===n)return i[t];i[t]=a}},debug:function(){s.debug&&(s.performance?i.performance.log(arguments):(i.debug=Function.prototype.bind.call(console.info,console,s.name+":"),i.debug.apply(console,arguments)))},verbose:function(){s.verbose&&s.debug&&(s.performance?i.performance.log(arguments):(i.verbose=Function.prototype.bind.call(console.info,console,s.name+":"),i.verbose.apply(console,arguments)))},error:function(){i.error=Function.prototype.bind.call(console.error,console,s.name+":"),i.error.apply(console,arguments)},performance:{log:function(e){var t,a,n;s.performance&&(t=(new Date).getTime(),n=l||t,a=t-n,l=t,u.push({Name:e[0],Arguments:[].slice.call(e,1)||"",Element:w,"Execution Time":a})),clearTimeout(i.performance.timer),i.performance.timer=setTimeout(i.performance.display,100)},display:function(){var t=s.name+":",a=0;l=!1,clearTimeout(i.performance.timer),e.each(u,function(e,t){a+=t["Execution Time"]}),t+=" "+a+"ms",c&&(t+=" '"+c+"'"),(console.group!==n||console.table!==n)&&u.length>0&&(console.groupCollapsed(t),console.table?console.table(u):e.each(u,function(e,t){console.log(t.Name+": "+t["Execution Time"]+"ms")}),console.groupEnd()),u=[]}},invoke:function(t,a,r){var s,c,l,u=F;return a=a||g,r=w||r,"string"==typeof t&&u!==n&&(t=t.split(/[\. ]/),s=t.length-1,e.each(t,function(a,o){var r=a!=s?o+t[a+1].charAt(0).toUpperCase()+t[a+1].slice(1):t;if(e.isPlainObject(u[r])&&a!=s)u=u[r];else{if(u[r]!==n)return c=u[r],!1;if(!e.isPlainObject(u[o])||a==s)return u[o]!==n?(c=u[o],!1):(i.error(T.method,t),!1);u=u[o]}})),e.isFunction(c)?l=c.apply(r,a):c!==n&&(l=c),e.isArray(o)?o.push(l):o!==n?o=[o,l]:l!==n&&(o=l),c}},b?(F===n&&i.initialize(),i.invoke(d)):(F!==n&&i.destroy(),i.initialize())}),i&&!b&&i.initializeHistory(),o!==n?o:this},e.tab=function(a){e(t).tab(a)},e.fn.tab.settings={name:"Tab",namespace:"tab",debug:!1,verbose:!1,performance:!1,auto:!1,history:!1,historyType:"hash",path:!1,context:!1,childrenOnly:!1,maxDepth:25,ignoreFirstLoad:!1,alwaysRefresh:!1,cache:!0,apiSettings:!1,onTabInit:function(){},onTabLoad:function(){},templates:{determineTitle:function(){}},error:{api:"You attempted to load content without API module",method:"The method you called is not defined",missingTab:"Activated tab cannot be found for this context.",noContent:"The tab you specified is missing a content url.",path:"History enabled, but no path was specified",recursion:"Max recursive depth reached",state:"The state library has not been initialized"},metadata:{tab:"tab",loaded:"loaded",promise:"promise"},className:{loading:"loading",active:"active",ui:"ui"},selector:{tabs:".ui.tab"}}}(jQuery,window,document);